﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Bullet : MonoBehaviour
{
    // Start is called before the first frame update
    private Vector3 m_velocity; // 速度

    //その弾の攻撃力
    public int power = 1;

    //その弾を発射したキャラ
    public int shotChara;
    // 毎フレーム呼び出される関数
    private void Update()
    {
        // 移動する
        transform.position += m_velocity;
    }

    ///<summary>玉発射の初期化処理
    /// <param name="angle">角度</param>
    /// <param name="speed">スピード</param>
    /// <param name="power">攻撃力</param>
    /// <param name="chara">そのショットを発射したキャラ</param>
    /// </summary>
    public void Init(float angle, float speed, int pow, int cha)
    {
        shotChara = cha;
        this.power = pow;
        // 弾の発射角度をベクトルに変換する
        var direction = GetDirection(angle);

        // 発射角度と速さから速度を求める
        m_velocity = direction * speed;

        // 弾が進行方向を向くようにする
        var angles = transform.localEulerAngles;
        angles.z = angle - 90;
        transform.localEulerAngles = angles;

        // 2 秒後に削除する
        Destroy(gameObject, 2);
    }

    // 指定された角度（ 0 ～ 360 ）をベクトルに変換して返す
    private static Vector3 GetDirection(float angle)
    {
        return new Vector3
        (
            Mathf.Cos(angle * Mathf.Deg2Rad),
            Mathf.Sin(angle * Mathf.Deg2Rad),
            0
        );
    }
}
