﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class GameManager : MonoBehaviour
{
    public PlayerController[] players;

    public Text winnerText;
    [SerializeField] float heiwaTime = 60.0f;        // ゲーム制限時間 [s]
    public float currentTime;                              // 残り時間タイマー
    public Text restTimeText;

    public KOFlash koFlash;
    //public GameObject Shuchuline; //集中線
    public bool pvpFlag = false;

    public bool gameEnd = false;
    public int timer = 0;
    // Start is called before the first frame update
    void Start()
    {
        pvpFlag = false;
        // 残り時間を設定
        currentTime = heiwaTime;
        gameEnd = false;
    }

    // Update is called once per frame
    void Update()
    {
        if (pvpFlag == false)
        {
            //準備時間の間だけ残り時間を計算する
            currentTime -= Time.deltaTime;
        }

        // ゼロ秒以下にならないようにする
        if (currentTime <= 0.0f && pvpFlag == false)
        {
            currentTime = 0.0f;

            PvpStart();
        }
        TimerTextUpdater();
        int loopNum = 1; //現在何回目のループか
        if (gameEnd == false)
        {
            winnerText.text = (""); //△P勝利！の文字を空っぽにする
            //ゲーム終了条件を満たしているか判定する
            foreach (PlayerController i in players)
            {
                if (i.deadFlag == true)
                {
                    koFlash.yobidashi = true;
                    //Instantiate(Shuchuline, transform.position, Quaternion.identity);
                    int wp = loopNum + 1;
                    if (wp == 3) { wp = 1; }//1PのHPが0になった場合2を、2PのHPが0になった場合1にする
                    Debug.Log("プレイヤー" + wp + "の勝利");
                    winnerText.text = ("Player " + wp + " Win!!");
                    gameEnd = true;
                    Invoke("ResetGame", 8.0f);
                }
                loopNum++;
            }
        }
    }

    private void ResetGame()
    {
        SceneManager.LoadScene("Title");
    }

    private void PvpStart()
    {
        koFlash.yobidashi = true;
        var bgm = GameObject.FindObjectOfType<BGM>();
        if (bgm != null)
        {
            bgm.PlayDuel();
        }

        int loopNum = 1; //現在何回目のループか
        pvpFlag = true;
        foreach (PlayerController i in players)
        {
            if (loopNum == 1) // 1Pの発射角度を変更
            {
                i.bulletAngleBase = 0;
                i.battleFlag = true;
            }
            else if (loopNum == 2) //2Pの発射角度を変更
            {
                i.bulletAngleBase = 180;
                i.battleFlag = true;
            }
            loopNum++;
        }
    }

    private void TimerTextUpdater()
    {
        int minutes = Mathf.FloorToInt(currentTime / 60F);
        int seconds = Mathf.FloorToInt(currentTime - minutes * 60);
        int mseconds = Mathf.FloorToInt((currentTime - minutes * 60 - seconds) * 10);
        if (seconds <= 9)
        {
            restTimeText.text = string.Format("{0:0}.{1:0}", seconds, mseconds);
        }
        else
        {
            restTimeText.text = string.Format("{0:00}", seconds);
        }
        if (pvpFlag == true)
        {
            restTimeText.text = string.Format("Duel!");
        }
    }
}
